#include "permute.h"
#include "byte.h"

unsigned int
npermutations(unsigned int n, unsigned int d)
{
    unsigned int p = 1;

#if 0
    /* XXX use this when we fix permute() to use d */
    while (n > d) {
	p *= n;
	n--;
    }
#else
    while (n > 1) {
	p *= n;
	n--;
    }
#endif

    return p;
}

void
permute(char *out, const char *in, unsigned int n, unsigned int p,  
    unsigned int d)
{
    unsigned int i;

    /* XXX fix this to take advantage of d */

    byte_copy(out, n, in);

    for (i = n; i > 0; --i) {
	unsigned int position = p % i;
	char t = out[position];
	p /= i;
	out[position] = out[0];
	out[0] = t;
	out++;
    }
}

